#include <iostream>
#include <algorithm>
using namespace std;
int main()
{
    int t;
    cin>>t;
    for(int i=0;i<t;i++)
    {
        int n,m,minn=0;d;
        cin>>n>>m;
        int a[n],b[m];
        for(int j=0;j<n;j++)
             cin>>a[j];
        sort(a,a+j)
        for(int k=0;k<m;k++)
             cin>>b[k];
        sort(b,b+k)
        for(int j=0;j<n;j++)
            {
                if((a[j+2]-a[j+1])%(a[j+1]-a[j])==0)
                 {
                     d=1;
                     x=a[j+1]-a[j];
                     if(x<minn)
                     minn=x;
                }
                 
                else
                    d=0;
            }
        for(int k=0;k<m;k++)
             if(b[k]%a[0]==min)
                {
                    d=0;
                    break;
                }
        cout<<d; 
    }
}